Unit DE36R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AS08R_p, UTDE16_p;

procedure DE36R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer;
                var JSTART :Integer; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var IR :Array of Integer; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var R5 :Array of Real;
                var IERR :Integer);

implementation

procedure DE36R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer;
                var JSTART :Integer; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var IR :Array of Integer; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var R5 :Array of Real;
                var IERR :Integer);
var
I,ISTR,J,J1,J2,JUMP,JUMP1,L :Integer;
H1,W,W1,W2,W3,W4 :Real;
BULH,BULHM :Boolean;
CMU :Array [0..14] of Real;
MU :Array [0..14] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320;
begin
{   DATA  FORTRAN  }
MU[0] := 0.1127016653792583;
MU[1] := 0.5;
MU[2] := 0.8872983346207417;
MU[3] := 0.1388888888888888;
MU[4] := -0.03597666752493890;
MU[5] := 0.9789444015308326e-2;
MU[6] := 0.3002631949808646;
MU[7] := 0.2222222222222222;
MU[8] := -0.02248541720308681;
MU[9] := 0.2679883337624695;
MU[10] := 0.4804211119693833;
MU[11] := 0.1388888888888889;
MU[12] := 0.2777777777777778;
MU[13] := 0.4444444444444444;
MU[14] := 0.2777777777777778;
IERR := 0;
for I:=1 to 15 do
 begin
  CMU[I-1] := MU[I-1]*H;
_10:
 end;
BULHM := False;
BULH := True;
if ( JSTART =  -1 ) 
 then goto _290;
if ( JSTART =  1 ) 
 then goto _20;
_COM36R.elm4 := M + 1;
_COM36R.elm5 := _COM36R.elm4 + M;
_COM36R.elm1 := M*3;
_COM36R.elm2 := _COM36R.elm1 + 1;
_COM36R.elm3 := _COM36R.elm1*_COM36R.elm1;
_COM36R.elm6 := M*_COM36R.elm1;
_20:
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_30:
 end;
XP := X;
_40:
JUMP1 := 1;
_COM36R.elm7 := EPS*63.0;
_COM36R.elm8 := _COM36R.elm7/128.0;
{   **********  BOHEHE AAHHOO AA  H   ********** }
goto _120;
{   **********  AOMHAHE PEEH  OEHK OPEHOCT  ********** }
_50:
for I:=1 to M do
 begin
  R4[I-1] := YX[I-1];
_60:
 end;
_70:
for I:=1 to 15 do
 begin
  CMU[I-1] := CMU[I-1]*0.5;
_80:
 end;
H1 := H*0.5;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_90:
 end;
X := XP;
JUMP1 := 2;
{   **********  BOHEHE EPBOO OOBHHOO AA  H/2    ********** }
goto _120;
_100:
for I:=1 to M do
 begin
  R5[I-1] := YX[I-1];
_110:
 end;
X := X + H1;
{   **********  BOHEHE BTOPOO OOBHHOO AA  H/2    ********** }
JUMP1 := 3;
{   **********  OPMPOBAHE PACPEHHO MATP   ********** }
_120:
W := X + CMU[0];
W1 := CMU[3];
W2 := CMU[4];
W3 := CMU[5];
ISTR := 1;
JUMP := 1;
goto _150;
_130:
W := X + CMU[1];
W1 := CMU[6];
W2 := CMU[7];
W3 := CMU[8];
ISTR := _COM36R.elm4;
JUMP := 2;
goto _150;
_140:
W := X + CMU[2];
W1 := CMU[9];
W2 := CMU[10];
W3 := CMU[11];
ISTR := _COM36R.elm5;
JUMP := 3;
{   **********  OPMPOBAHE OPOHTAHO OOC B PACPEHHO  ******* }
{   **********   MATPE  ********** }
_150:
FA(R3,W,M);
FI(R2,W,M);
J := ISTR - 1;
for I:=1 to M do
 begin
  J := J + 1;
  W := 0.0;
  J1 := J - _COM36R.elm1;
  for L:=1 to M do
   begin
    J1 := J1 + _COM36R.elm1;
    W4 := R3[(I-1)+(L-1)*M];
    R1[J1-1] := W4*W1;
    J2 := J1 + _COM36R.elm6;
    R1[J2-1] := W4*W2;
    J2 := J2 + _COM36R.elm6;
    R1[J2-1] := W4*W3;
    W := W + W4*YX[L-1];
_160:
   end;
  L := _COM36R.elm3 + J;
  R1[L-1] := -R2[I-1] - W;
_170:
 end;
case JUMP of
 1: goto _130;
 2: goto _140;
 3: goto _180;
end;
_180:
I := 1;
while ( I<=_COM36R.elm3 ) do
 begin
  R1[I-1] := R1[I-1] - 1.0;
_190:
  inc(I,_COM36R.elm2);
 end;
AS08R(_COM36R.elm1,0,_COM36R.elm1,R1,R2,IR);
for I:=1 to M do
 begin
  J := I + M;
  J1 := J + M;
  YX[I-1] := YX[I-1] + CMU[12]*R2[I-1] + CMU[13]*R2[J-1] + CMU[14]*
    R2[J1-1];
_200:
 end;
case JUMP1 of
 1: goto _50;
 2: goto _100;
 3: goto _210;
end;
_210:
for I:=1 to M do
 begin
  W := YX[I-1] - R4[I-1];
  if ( Abs(YX[I-1]) >  P ) 
   then W := W/YX[I-1];
  W := Abs(W);
  if ( W <=  _COM36R.elm7 ) 
   then goto _220;
  if ( BULHM ) 
   then goto _310;
  H := H1;
  BUL := False;
  BULH := False;
  if ( Abs(H) >  Abs(HMIN) ) 
   then goto _240;
  H := Sign(HMIN,H);
  BULHM := True;
  goto _260;
_220:
  if ( W <  _COM36R.elm8 ) 
   then goto _230;
  BULH := False;
_230:
 end;
X := X + H1;
if ( BULH ) 
 then H := H + H;
goto _320;
_240:
for I:=1 to M do
 begin
  R4[I-1] := R5[I-1];
_250:
 end;
goto _70;
_260:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_270:
 end;
for I:=1 to 15 do
 begin
  CMU[I-1] := MU[I-1]*H;
_280:
 end;
X := XP;
goto _40;
_290:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_300:
 end;
X := XP;
goto _40;
_310:
IERR := 65;
UTDE16(IERR,36);
_320:
JSTART := 1;
end;

end.
